function initialize!(integrator, ::QPRK98ConstantCache)
    integrator.fsalfirst = integrator.f(integrator.uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    # Avoid undefined entries if k is an array of arrays
    integrator.fsallast = zero(integrator.fsalfirst)
    integrator.k[1] = integrator.fsalfirst
    return integrator.k[2] = integrator.fsallast
end

@muladd function perform_step!(integrator, ::QPRK98ConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    T = constvalue(recursive_unitless_bottom_eltype(u))
    T2 = constvalue(typeof(one(t)))
    @OnDemandTableauExtract QPRK98Tableau T T2

    k1 = integrator.fsalfirst
    k2 = f(uprev + b21 * k1 * dt, p, t + d2 * dt)
    k3 = f(uprev + dt * (b31 * k1 + b32 * k2), p, t + d3 * dt)
    k4 = f(uprev + dt * (b41 * k1 + b43 * k3), p, t + d4 * dt)
    k5 = f(uprev + dt * (b51 * k1 + b53 * k3 + b54 * k4), p, t + d5 * dt)
    k6 = f(uprev + dt * (b61 * k1 + b64 * k4 + b65 * k5), p, t + d6 * dt)
    k7 = f(uprev + dt * (b71 * k1 + b74 * k4 + b75 * k5 + b76 * k6), p, t + d7 * dt)
    k8 = f(uprev + dt * (b81 * k1 + b86 * k6 + b87 * k7), p, t + d8 * dt)
    k9 = f(uprev + dt * (b91 * k1 + b96 * k6 + b97 * k7 + b98 * k8), p, t + d9 * dt)
    k10 = f(
        uprev + dt * (b10_1 * k1 + b10_6 * k6 + b10_7 * k7 + b10_8 * k8 + b10_9 * k9),
        p, t + d10 * dt
    )
    k11 = f(
        uprev +
            dt * (
            b11_1 * k1 + b11_6 * k6 + b11_7 * k7 + b11_8 * k8 + b11_9 * k9
                + b11_10 * k10
        ),
        p,
        t + d11 * dt
    )
    k12 = f(
        uprev +
            dt * (
            b12_1 * k1 + b12_6 * k6 + b12_7 * k7 + b12_8 * k8 + b12_9 * k9
                + b12_10 * k10 + b12_11 * k11
        ),
        p,
        t + d12 * dt
    )
    k13 = f(
        uprev +
            dt * (
            b13_1 * k1 + b13_6 * k6 + b13_7 * k7 + b13_8 * k8 + b13_9 * k9
                + b13_10 * k10 + b13_11 * k11 + b13_12 * k12
        ),
        p,
        t + d13 * dt
    )
    k14 = f(
        uprev +
            dt * (
            b14_1 * k1 + b14_6 * k6 + b14_7 * k7 + b14_8 * k8 + b14_9 * k9
                + b14_10 * k10 + b14_11 * k11 + b14_12 * k12 + b14_13 * k13
        ),
        p,
        t + d14 * dt
    )
    k15 = f(
        uprev +
            dt * (
            b15_1 * k1 + b15_6 * k6 + b15_7 * k7 + b15_8 * k8 + b15_9 * k9
                + b15_10 * k10 + b15_11 * k11 + b15_12 * k12 + b15_13 * k13 + b15_14 * k14
        ),
        p, t + dt
    )
    k16 = f(
        uprev +
            dt * (
            b16_1 * k1 + b16_6 * k6 + b16_7 * k7 + b16_8 * k8 + b16_9 * k9
                + b16_10 * k10 + b16_11 * k11 + b16_12 * k12 + b16_13 * k13 + b16_14 * k14
        ),
        p, t + dt
    )
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 15)
    u = uprev +
        dt * (
        w1 * k1 + w8 * k8 + w9 * k9 + w10 * k10 + w11 * k11 + w12 * k12 +
            w13 * k13 + w14 * k14 + w15 * k15 + w16 * k16
    )

    if integrator.opts.adaptive
        utilde = dt * (
            ϵ1 * k1 + ϵ8 * k8 + ϵ9 * k9 + ϵ10 * k10 + ϵ11 * k11 + ϵ12 * k12 +
                ϵ13 * k13 + ϵ14 * k14 + ϵ15 * k15
        )
        atmp = calculate_residuals(
            utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
end

function initialize!(integrator, cache::QPRK98Cache)
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.f(integrator.fsalfirst, integrator.uprev, integrator.p, integrator.t) # Pre-start fsal
    return OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
end

@muladd function perform_step!(integrator, cache::QPRK98Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p) = integrator
    T = constvalue(recursive_unitless_bottom_eltype(u))
    T2 = constvalue(typeof(one(t)))
    @OnDemandTableauExtract QPRK98Tableau T T2
    (;
        fsalfirst, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, k14, k15, k16,
        utilde, tmp, atmp, k, stage_limiter!, step_limiter!, thread,
    ) = cache
    k1 = fsalfirst
    f(k1, uprev, p, t)
    @.. broadcast = false thread = thread tmp = uprev + dt * b21 * k1
    stage_limiter!(tmp, integrator, p, t + d2 * dt)
    f(k2, tmp, p, t + d2 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (b31 * k1 + b32 * k2)
    stage_limiter!(tmp, integrator, p, t + d3 * dt)
    f(k3, tmp, p, t + d3 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (b41 * k1 + b43 * k3)
    stage_limiter!(tmp, integrator, p, t + d4 * dt)
    f(k4, tmp, p, t + d4 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (b51 * k1 + b53 * k3 + b54 * k4)
    stage_limiter!(uprev, integrator, p, t + d5 * dt)
    f(k5, tmp, p, t + d5 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (b61 * k1 + b64 * k4 + b65 * k5)
    stage_limiter!(tmp, integrator, p, t + d6 * dt)
    f(k6, tmp, p, t + d6 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b71 * k1 + b74 * k4 + b75 * k5
            + b76 * k6
    )
    stage_limiter!(tmp, integrator, p, t + d7 * dt)
    f(k7, tmp, p, t + d7 * dt)
    @.. broadcast = false thread = thread tmp = uprev + dt * (b81 * k1 + b86 * k6 + b87 * k7)
    stage_limiter!(tmp, integrator, p, t + d8 * dt)
    f(k8, tmp, p, t + d8 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b91 * k1 + b96 * k6 + b97 * k7
            + b98 * k8
    )
    stage_limiter!(tmp, integrator, p, t + d9 * dt)
    f(k9, tmp, p, t + d9 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b10_1 * k1 + b10_6 * k6
            + b10_7 * k7 + b10_8 * k8 + b10_9 * k9
    )
    stage_limiter!(tmp, integrator, p, t + d10 * dt)
    f(k10, tmp, p, t + d10 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b11_1 * k1 + b11_6 * k6
            + b11_7 * k7 + b11_8 * k8 + b11_9 * k9
            + b11_10 * k10
    )
    stage_limiter!(tmp, integrator, p, t + d11 * dt)
    f(k11, tmp, p, t + d11 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b12_1 * k1 + b12_6 * k6
            + b12_7 * k7 + b12_8 * k8 + b12_9 * k9
            + b12_10 * k10 + b12_11 * k11
    )
    stage_limiter!(tmp, integrator, p, t + d12 * dt)
    f(k12, tmp, p, t + d12 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b13_1 * k1 + b13_6 * k6
            + b13_7 * k7 + b13_8 * k8 + b13_9 * k9
            + b13_10 * k10 + b13_11 * k11 + b13_12 * k12
    )
    stage_limiter!(tmp, integrator, p, t + d13 * dt)
    f(k13, tmp, p, t + d13 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b14_1 * k1 + b14_6 * k6
            + b14_7 * k7 + b14_8 * k8 + b14_9 * k9
            + b14_10 * k10 + b14_11 * k11 + b14_12 * k12
            + b14_13 * k13
    )
    stage_limiter!(tmp, integrator, p, t + d14 * dt)
    f(k14, tmp, p, t + d14 * dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b15_1 * k1 + b15_6 * k6
            + b15_7 * k7 + b15_8 * k8 + b15_9 * k9
            + b15_10 * k10 + b15_11 * k11 + b15_12 * k12
            + b15_13 * k13 + b15_14 * k14
    )
    stage_limiter!(tmp, integrator, p, t + dt)
    f(k15, tmp, p, t + dt)
    @.. broadcast = false thread = thread tmp = uprev +
        dt * (
        b16_1 * k1 + b16_6 * k6
            + b16_7 * k7 + b16_8 * k8 + b16_9 * k9
            + b16_10 * k10 + b16_11 * k11 + b16_12 * k12
            + b16_13 * k13 + b16_14 * k14
    )
    stage_limiter!(u, integrator, p, t + dt)
    f(k16, tmp, p, t + dt)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 16)

    @.. broadcast = false thread = thread u = uprev +
        dt * (
        w1 * k1 + w8 * k8 + w9 * k9
            + w10 * k10 + w11 * k11 + w12 * k12 + w13 * k13
            + w14 * k14 + w15 * k15 + w16 * k16
    )
    stage_limiter!(u, integrator, p, t + dt)
    step_limiter!(u, integrator, p, t + dt)

    if integrator.opts.adaptive
        @.. broadcast = false thread = thread utilde = dt * (
            ϵ1 * k1 + ϵ8 * k8 +
                ϵ9 * k9 +
                ϵ10 * k10 + ϵ11 * k11 +
                ϵ12 * k12 +
                ϵ13 * k13 + ϵ14 * k14 +
                ϵ15 * k15
        )
        calculate_residuals!(
            atmp, utilde, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t,
            thread
        )
        integrator.EEst = integrator.opts.internalnorm(atmp, t)
    end
    f(k, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return nothing
end

struct QPRK98ConstantCache <: OrdinaryDiffEqConstantCache end

@cache struct QPRK98Cache{
        uType, rateType, uNoUnitsType, StageLimiter, StepLimiter, Thread,
    } <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    fsalfirst::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    k6::rateType
    k7::rateType
    k8::rateType
    k9::rateType
    k10::rateType
    k11::rateType
    k12::rateType
    k13::rateType
    k14::rateType
    k15::rateType
    k16::rateType
    utilde::uType
    tmp::uType
    atmp::uNoUnitsType
    k::rateType
    stage_limiter!::StageLimiter
    step_limiter!::StepLimiter
    thread::Thread
end

get_fsalfirstlast(cache::QPRK98Cache, u) = (cache.fsalfirst, cache.k)

function alg_cache(
        alg::QPRK98, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits},
        uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    k5 = zero(rate_prototype)
    k6 = zero(rate_prototype)
    k7 = zero(rate_prototype)
    k8 = zero(rate_prototype)
    k9 = zero(rate_prototype)
    k10 = zero(rate_prototype)
    k11 = zero(rate_prototype)
    k12 = zero(rate_prototype)
    k13 = zero(rate_prototype)
    k14 = zero(rate_prototype)
    k15 = zero(rate_prototype)
    k16 = zero(rate_prototype)
    utilde = zero(u)
    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    k = zero(rate_prototype)
    recursivefill!(atmp, false)
    return QPRK98Cache(
        u, uprev, k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12, k13, k14, k15,
        k16, utilde, tmp, atmp, k, alg.stage_limiter!, alg.step_limiter!,
        alg.thread
    )
end

function alg_cache(
        ::QPRK98, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return QPRK98ConstantCache()
end

using OrdinaryDiffEqQPRK, DiffEqDevTools, Test, Random
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear, prob_ode_bigfloat2Dlinear

Random.seed!(100)

dts = BigFloat.(1 .// 2 .^ (6:-1:2))
testTol = 0.35

# Tests on simple problem

f = (u, p, t) -> cos(t)
prob_ode_sin = ODEProblem(
    ODEFunction(f; analytic = (u0, p, t) -> sin(t)),
    BigFloat(0.0),
    (BigFloat(0.0), BigFloat(1.0))
)

f = (du, u, p, t) -> du[1] = cos(t)
prob_ode_sin_inplace = ODEProblem(
    ODEFunction(f; analytic = (u0, p, t) -> [sin(t)]),
    [BigFloat(0.0)],
    (BigFloat(0.0), BigFloat(1.0))
)

f = (u, p, t) -> sin(u)
prob_ode_nonlinear = ODEProblem(
    ODEFunction(
        f; analytic = (u0, p, t) -> BigFloat(2.0) * acot(
            exp(-t)
                * cot(BigFloat(0.5))
        )
    ),
    BigFloat(1.0),
    (BigFloat(0.0), BigFloat(0.5))
)

f = (du, u, p, t) -> du[1] = sin(u[1])
prob_ode_nonlinear_inplace = ODEProblem(
    ODEFunction(
        f; analytic = (u0, p, t) -> [
            BigFloat(2.0) * acot(
                exp(-t)
                    * cot(BigFloat(0.5))
            ),
        ]
    ),
    [BigFloat(1.0)],
    (BigFloat(0.0), BigFloat(0.5))
)

test_problems_only_time = [prob_ode_sin, prob_ode_sin_inplace]
test_problems_linear = [prob_ode_bigfloat2Dlinear]
test_problems_nonlinear = [prob_ode_nonlinear, prob_ode_nonlinear_inplace]

println("QPRK98")
alg = QPRK98()

for prob in test_problems_only_time
    sim = test_convergence(dts, prob, alg)
    sim.𝒪est[:final]
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqQPRK.alg_order(alg) + 1 atol = testTol
    sol = solve(prob, alg, adaptive = true, save_everystep = true)
    sol_exact = prob.f.analytic(prob.u0, prob.p, sol.t[end])
    @test length(sol) < 7
    @test SciMLBase.successful_retcode(sol)
    @test minimum(abs.(sol.u[end] .- sol_exact) .< 1.0e-12)
end

for prob in test_problems_linear
    sim = test_convergence(BigFloat.(dts), prob, alg)
    sim.𝒪est[:final]
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqQPRK.alg_order(alg) + 1 atol = testTol
    sol = solve(prob, alg, adaptive = true, save_everystep = true)
    sol_exact = prob.f.analytic(prob.u0, prob.p, sol.t[end])
    @test length(sol) < 5
    @test SciMLBase.successful_retcode(sol)
    @test minimum(abs.(sol.u[end] .- sol_exact) .< 1.0e-8)
end

for prob in test_problems_nonlinear
    sim = test_convergence(dts, prob, alg)
    sim.𝒪est[:final]
    @test sim.𝒪est[:final] ≈ OrdinaryDiffEqQPRK.alg_order(alg) + 2.5 atol = testTol
    sol = solve(prob, alg, adaptive = true, save_everystep = true)
    sol_exact = prob.f.analytic(prob.u0, prob.p, sol.t[end])
    @test length(sol) < 5
    @test SciMLBase.successful_retcode(sol)
    @test minimum(abs.(sol.u[end] .- sol_exact) .< 1.0e-11)
end

using SafeTestsets

@time @safetestset "Quadruple Precision Tests" include("ode_quadruple_precision_tests.jl")
@time @safetestset "JET Tests" include("jet.jl")
@time @safetestset "Aqua" include("qa.jl")

@doc explicit_rk_docstring(
    "Runge–Kutta pairs of orders 9(8) for use in quadruple precision computations", "QPRK98",
    references = "Kovalnogov VN, Fedorov RV, Karpukhina TV, Simos TE, Tsitouras C. Runge–Kutta pairs 
    of orders 9 (8) for use in quadruple precision computations. Numerical Algorithms, 2023. 
    doi: https://doi.org/10.1007/s11075-023-01632-8"
)
Base.@kwdef struct QPRK98{StageLimiter, StepLimiter, Thread} <:
    OrdinaryDiffEqAdaptiveAlgorithm
    stage_limiter!::StageLimiter = trivial_limiter!
    step_limiter!::StepLimiter = trivial_limiter!
    thread::Thread = False()
end
# for backwards compatibility
function QPRK98(stage_limiter!, step_limiter! = trivial_limiter!)
    return QPRK98(stage_limiter!, step_limiter!, False())
end

module OrdinaryDiffEqQPRK

import OrdinaryDiffEqCore: OrdinaryDiffEqAdaptiveAlgorithm, OrdinaryDiffEqConstantCache,
    explicit_rk_docstring, @cache,
    OrdinaryDiffEqMutableCache,
    OrdinaryDiffEqAdaptiveAlgorithm, @fold, @OnDemandTableauExtract,
    trivial_limiter!, alg_cache, alg_order, initialize!,
    perform_step!, get_fsalfirstlast,
    constvalue, calculate_residuals!, calculate_residuals,
    full_cache
using Static: False
using MuladdMacro, FastBroadcast
using RecursiveArrayTools: recursive_unitless_bottom_eltype, recursivefill!
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("qprk_caches.jl")
include("qprk_tableaus.jl")
include("qprk_perform_step.jl")

export QPRK98

end
